# Create a custom moderation view

{% hint style="success" %}
This is the official documentation of the `@forestadmin/agent` Node.js agent.
{% endhint %}

This example shows you how you can implement a moderation view with a custom Approve/Reject workflow.

![](/files/zVaaX4fA3MW14ZxU0XfF)

In our example, we want to Approve or Reject products to moderate content on our website, and more specifically, we want to:

* preview products images,
* bulk Approve/Reject products.

### How it works

#### Smart View definition

Learn more about [Smart Views](/developer-guide-agents-nodejs/frontend-customization/smart-views.md).

**File template.hbs**

This file contains the HTML and CSS needed to build the view.

{% tabs %}
{% tab title="Template" %}

```handlebars
<div class='view-wrapper'>
  <div class='table-wrapper'>
    <table class='c-table-frame'>
      <thead class='l-table-frame-headers'>
        <tr class='l-table-frame-headers-line'>
          <th
            scope='col'
            role='button'
            class='c-table-frame__header c-table-frame__header--select-all'
          >
            <div class='c-table-frame__checkbox-select-all'>
              <div class='l-table-frame-checkbox-select-all'>
                <BetaCheckbox
                  @value={{this.allSelected}}
                  @small={{true}}
                  @disabled={{false}}
                  @onChange={{fn this.selectAll}}
                />
              </div>
            </div>
          </th>
          <th scope='col' class='c-table-frame__header c-table-column-header'>
            <span class='c-table-column-header__content'>
              <span
                class='c-table-column-header__display-name c-table-column-header__display-name--sortable c-table-column-header__display-name--first'
                role='button'
              >
                Product details
              </span>
            </span>
          </th>
          <th scope='col' class='c-table-frame__header c-table-column-header'>
            <span class='c-table-column-header__content'>
              <span class='c-table-column-header__display-name' role='button'>
                Images
              </span>
            </span>
          </th>
          <th scope='col' class='c-table-frame__header c-table-column-header'>
            <span class='c-table-column-header__content'>
              <span class='c-table-column-header__display-name' role='button'>
                <Button::BetaButton
                  @type='primary'
                  @text='Approve'
                  @size='tiny'
                  @action={{fn
                    this.triggerSmartAction
                    @collection
                    'Approve'
                    this.selectedRecords
                  }}
                  @disabled={{this.disableButtons}}
                  @class='no-margin'
                />
                <Button::BetaButton
                  @type='danger'
                  @text='Reject'
                  @size='tiny'
                  @disabled={{this.disableButtons}}
                  @action={{fn
                    this.triggerSmartAction
                    @collection
                    'Reject'
                    this.selectedRecords
                  }}
                  @class='no-margin'
                />
              </span>
            </span>
          </th>
        </tr>
      </thead>
      <tbody class='l-table-frame-body'>
        {{#each this.formatedRecords as |record|}}
          <tr>
            <td class='align-top first-column' role=''>
              <BetaCheckbox
                @value={{record._selected}}
                @small={{true}}
                @disabled={{false}}
                @onChange={{fn this.selectRecord}}
              />
            </td>
            <td class='align-top'>
              <div class='title'>
                <LinkTo
                  @route='project.rendering.data.collection.list.viewEdit.details'
                  @models={{array @collection.id record.id}}
                >
                  {{record.forest-name}}
                </LinkTo>
              </div>
              <div class='status'>
                <span
                  class='c-badge'
                  style='--badge-color:#0cc251; --badge-background-color:#0cc25133;'
                >
                  <p class='c-badge__label'>
                    {{record.forest-state}}
                  </p>
                </span>
              </div>
            </td>
            <td class='second-column'>
              {{#each record.forest-imagesSF as |image|}}
                <Widgets::Display::FileViewer::WidgetLayout
                  @value={{image}}
                  @field={{this.pictureField}}
                />
              {{/each}}
            </td>
          </tr>
        {{/each}}
      </tbody>
    </table>
  </div>

  <Table::TableFooter
    @collection={{@collection}}
    @records={{@records}}
    @selectedRecordsCount={{this.selectedRecords.length}}
    @recordsCount={{@recordsCount}}
    @currentPage={{@currentPage}}
    @numberOfPages={{@numberOfPages}}
    @fetchRecords={{@fetchRecords}}
    @canEdit={{@canEdit}}
    @isLoading={{@isLoading}}
    @displaySearchExtendedButton={{@displaySearchExtendedButton}}
    @disablePagination={{false}}
    @hasShowMore={{false}}
    @class='pagination'
  />
</div>
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-nodejs/frontend-customization/smart-views/create-a-custom-moderation-view.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
